class ProgressBar:
  """
  The base class for progress bars
  """
  
  def __init__(self):
    self.min = 0
    self.max = 100
    self.value = self.min
    self.precision = 0
    self.maxPrecision = 3
    
  def setPrecision(self, precision):
    self.precision = min(self.maxPrecision, max(0, int(precision)))    

  def setValue(self, value):
    self.value = min(self.max, max(self.min, value))    
    
  def getNormalisedValue(self):
    """
    Return the normalized stored value as a float in the range [0, 1]
    """
    return max(0.0, min(1.0, abs(float(self.value - self.min) / (self.max - self.min))))
    
  def formatPercent(self):
    """
    Format the progress bar value as a percentage
    """
    return ("%." + str(self.precision) + "f%%") % (self.getNormalisedValue() * 100)
